{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}


    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            Employee:{routeName:'Employee-getComboValues',table:'employees',modulename:'Employee',fieldId:'code',fieldDisplay:'name'}
            //,setRights:{routeName:'OperationAuthorizationEmployee-setRights'}
            //,getQuestions:{routeName:'OperationAuthorizationEmployee-getQuestions'}
        },
        init : function(){
            var t = this;
            t.gridLoaded=false;
            {{ modulename }}Obj.superclass.init.call(t);
            t.windowButtons=false;
            t.layout = new mj.layout({
                renderTo : t.tabs.main.form.getBody(),
                layout : 'border',
                items : [
                    {
                        region : 'north',
                        initial : 40,
                        min : 40,
                        max : 40,
                        split : true,
                        collapsible : true
                    }
                ]
            });
            const gridConfig = {
                renderTo : t.layout.getBody('center'),
                pbar : false,
                fitToParent : true,
                sortable : false,
                selectMode : 'cell',
				cm: [
					{header: "{{ 'OperationAuthorizationEmployee.opname'|trans }}", dataIndex: 'opname', width: 400,alias:'oae'},
					{header: "{{ 'OperationAuthorizationEmployee.description'|trans }}", dataIndex: 'description', width: 200,alias:'oae'},
					{header: "{{ 'OperationAuthorizationEmployee.l1'|trans }}", dataIndex: 'l1', width: 30,alias:'oae',renderer:mj.renderer.check()},
					{header: "{{ 'OperationAuthorizationEmployee.l2'|trans }}", dataIndex: 'l2', width: 30,alias:'oae',renderer:mj.renderer.check()},
					{header: "{{ 'OperationAuthorizationEmployee.l3'|trans }}", dataIndex: 'l3', width: 30,alias:'oae',renderer:mj.renderer.check()},
					{header: "{{ 'OperationAuthorizationEmployee.l4'|trans }}", dataIndex: 'l4', width: 30,alias:'oae',renderer:mj.renderer.check()},
					//{header: "{{ 'OperationAuthorizationEmployee.l5'|trans }}", dataIndex: 'l5', width: 30,alias:'oae',renderer:mj.renderer.check()},
                    {header: "{{ 'OperationAuthorizationEmployee.question'|trans }}", dataIndex: 'question', width: 26,renderer:function(){
                        return '<center><div class="mj-question" style="height:16px;float:none;"></div></center>';
                    }},
                    {header: "{{ 'OperationAuthorizationEmployee.decrease'|trans }}", dataIndex: 'decrease', width: 26,renderer:function(){
                        return '<center><div class="mj-delete" style="height:16px;float:none;"></div></center>';
                    }},
                    //{header: t.ml.hedef, dataIndex: 'hedef', width: 30,align:'right'},
                    {header: "{{ 'OperationAuthorizationEmployee.increase'|trans }}", dataIndex: 'increase', width: 26,renderer:function(){
                        return '<center><div class="mj-add" style="height:16px;float:none;"></div></center>';
                    }}
				]
			};

			t._setGridConfig(gridConfig);
            const formConfig= {
                renderTo : t.layout.getBody('north'),
                buttonPos:false,
                items: [
                    new mj.form.combo({
                        title: "{{ 'OperationAuthorizationEmployee.employee'|trans }}",
                        placeHolder: "{{ 'OperationAuthorizationEmployee.employee'|trans }}",
                        dataIndex: 'employee',
                        clearOnTriggerClick: true,
                        sameValueDisplay:false,
                        labelWidth : '70px',
                        grid: 's6 m4',
                        width: 200,
                        store: t.stores.Employee
                    }),
                    new mj.form.textField({
                        title: "{{ 'OperationAuthorizationEmployee.opname'|trans }}",
                        dataIndex: 'opname',
                        maxLength: 50,
                        labelWidth : '80px',
                        grid: 'l4 m2',
                        width: 200,
                        right:true
                    })
                    //,new mj.form.checkBox({
                    //    title: "{{ 'OperationAuthorizationEmployee.l1'|trans }}",
                    //    dataIndex: 'l1',
                    //    labelWidth : '30px',
                    //    grid: 'none',
                    //    right:true,
                    //    handler:function(){
                    //        if(this.checked&&t.f_el_cmb_employee.getValue()&&t.f_el_cmb_employee.getValue()!==null){
                    //            var p = t.stores.setRights.params;
                    //            p.l1=1;
                    //            p.employee=t.f_el_cmb_employee.getValue();
                    //            t.waitMaskShow();
                    //            var routeName = t.modulename + '-setRightsLevelAllOperations';
                    //            var route = Routing.getRoute(routeName);
                    //            var pagerParams = {'pg':1,'lm':20};
                    //            var url = Routing.generate(routeName, pagerParams);
                    //            t.stores.setRights.url=url;
                    //            t.stores.setRights.preloaded=false;
                    //            t.stores.setRights.params.menuId=t.id;
                    //            t.stores.setRights.load();
                    //            delete p.l1;
                    //        }
                    //        
                    //    }
                    //})
                ]
            };

            t._setFormConfig(formConfig,t.initFormElementsEvents);

            t.stores.setAnswers = new mj.store({url : '',params : {}});
            t.stores.setRights = new mj.store({url : '',params : {}});
            t.stores.getQuestions = new mj.store({url : '',params : {}});
            t.f_el_cmb_employee=t.forms.main.items[0];
            t.f_el_txt_opname=t.forms.main.items[1];

            t.f_el_cmb_employee.view.on('itemclick',function(){
                t.stores.main.params.employee = t.f_el_cmb_employee.getValue();
                t.stores.main.params.opname = t.f_el_txt_opname.getElValue();
                var routeName = t.modulename + '-showall';
                var route = Routing.getRoute(routeName);
                var pagerParams = {'pg':1,'lm':(t.stores.main.params.opname.length>3?5000:20)/*,'employee':t.f_el_cmb_employee.getValue(),'opname':t.f_el_txt_opname.getElValue()*/};
                var url = Routing.generate(routeName, pagerParams);
                t.stores.main.url=url;
                t.stores.main.preloaded=false;
                t.stores.main.load();
            });

            t.f_el_txt_opname.on('change',function(){
                var emp=t.f_el_cmb_employee.getValue();
                if(((emp&&emp.length>0)===true)&&t.f_el_txt_opname.getElValue().length>3){
                    t.stores.main.params.employee = t.f_el_cmb_employee.getValue();
                    t.stores.main.params.opname = t.f_el_txt_opname.getElValue();
                    var routeName = t.modulename + '-showall';
                    var route = Routing.getRoute(routeName);
                    var pagerParams = {'pg':1,'lm':5000/*,'employee':t.f_el_cmb_employee.getValue(),'opname':t.f_el_txt_opname.getElValue()*/};
                    var url = Routing.generate(routeName, pagerParams);
                    t.stores.main.url=url;
                    t.stores.main.preloaded=false;
                    t.stores.main.load();
                }
            });
            t.grids.main.mask.show();
            //t.stores.setRights.params={};
            t.cellcheck=function(ri,ci,v){
                //console.log('ri:'+ri+' ci:'+ci+' v:'+v);
                var d = t.grids.main.selectedRow.data;
                var p = t.stores.setRights.params;
                p.l1=d.l1;
                p.l2=d.l2;
                p.l3=d.l3;
                p.l4=d.l4;
                //p.l5=d.l5;
                if(ci==7){
                    if(parseInt(t.grids.main.selectedRow.data.l2)==1){
                        t.win_questions.show();
                        t.win_questions.waitMask[0].style.display='block';
                        t.win_questions.buttons[0].setDisable();
                        t.win_questions.buttons[1].setDisable();
                        var routeName = t.modulename + '-getQuestions';
                        var route = Routing.getRoute(routeName);
                        var pagerParams = {'pg':1,'lm':(t.f_el_txt_opname.getElValue().length>3?5000:20)/*,'employee':t.f_el_cmb_employee.getValue(),'opname':t.f_el_txt_opname.getElValue()*/};
                        var url = Routing.generate(routeName, pagerParams);
                        t.stores.getQuestions.url=url;
                        t.stores.getQuestions.preloaded=false;
                        t.stores.getQuestions.params.menuId=t.id;
                        t.stores.getQuestions.params.opname=t.grids.main.selectedRow.data.opname;
                        t.stores.getQuestions.params.employee=t.f_el_cmb_employee.getValue();
                        t.stores.getQuestions.load();
                    }
                }
                if(ci==8){//hdusur
                    //d.hedef=d.hedef>0?d.hedef-1:0;
                    //t.grids.main.setCellValue(ri,8,d.hedef,false,true);
                    //p.hedef=d.hedef;
                    //if(d5==1) t.cellcheck(ri,ci-1,1);
                    p.op='down';
                    /*if(d.l5==1){
                        t.grids.main.setCellValue(ri,6,0,mj.renderer.check(),true);
                    }else */if(d.l4==1){
                        t.grids.main.setCellValue(ri,5,0,mj.renderer.check(),true);
                    }else if(d.l3==1){
                        t.grids.main.setCellValue(ri,4,0,mj.renderer.check(),true);
                    }else if(d.l2==1){
                        t.grids.main.setCellValue(ri,3,0,mj.renderer.check(),true);
                    }else if(d.l1==1){
                        t.grids.main.setCellValue(ri,2,0,mj.renderer.check(),true);
                    }
                }
                if(ci==9){//hyukselt
                    //d.hedef++;
                    //t.grids.main.setCellValue(ri,8,d.hedef,false,true);
                    //p.hedef=d.hedef;
                    //if(d5==1) t.cellcheck(ri,ci-1,1);
                    p.op='up';
                    if(d.l1==0){
                        t.grids.main.setCellValue(ri,2,1,mj.renderer.check(),true);
                    }else if(d.l2==0){
                        t.grids.main.setCellValue(ri,3,1,mj.renderer.check(),true);
                    }else if(d.l3==0){
                        t.grids.main.setCellValue(ri,4,1,mj.renderer.check(),true);
                    }else if(d.l4==0){
                        t.grids.main.setCellValue(ri,5,1,mj.renderer.check(),true);
                    }/*else if(d.l5==0){
                        t.grids.main.setCellValue(ri,6,1,mj.renderer.check(),true);
                    }*/
                }
            };
            
            t.grids.main.on('cellclick',function(g,ri,ci,ce){
                /*if(t.fc){
                    t.fc = false;
                    t.buttons.formSubmitBtn.setEnable();
                }*/
                t.grids.main.selectedRow.data = t.grids.main.store.data[ri];
                var d = t.grids.main.selectedRow.data;
                var p = t.stores.setRights.params;
                p.employee=t.f_el_cmb_employee.getValue();
                p.opname=d.opname;
                t.cellcheck(ri,ci,-1);
                if((ci==8&&p.l1==1)/*(ci==9&&p.l1==1)*/){//düşürme
                // önce sebep pencere aç, sonra kayıt yap
                    t.txtdusursebep.setValue('');
                    t.win_decreasedescription.show();
                }
                if((ci==9&&p.l4==0)/*(ci==10&&p.l5==0)*/){//yükseltme
                    t.waitMaskShow();
                    //console.log(t.stores.setRights.params);
                    var routeName = t.modulename + '-setRights';
                    var route = Routing.getRoute(routeName);
                    var pagerParams = {'pg':1,'lm':(t.f_el_txt_opname.getElValue().length>3?5000:20)/*,'employee':t.f_el_cmb_employee.getValue(),'opname':t.f_el_txt_opname.getElValue()*/};
                    var url = Routing.generate(routeName, pagerParams);
                    t.stores.setRights.url=url;
                    t.stores.setRights.preloaded=false;
                    t.stores.setRights.params.menuId=t.id;
                    t.stores.setRights.load();
                    delete p.l1;
                    delete p.l2;
                    delete p.l3;
                    delete p.l4;
                    //delete p.l5;
                }
            });
            t.stores.setRights.on('load',function(data){
                //console.log('load');
                //console.log(this);
                if(this._json&&this._json.error){
                    t.grids.main.load();
                //}else if(this.url.indexOf('setRightsLevelAllOperations')>-1){
                //    t.waitMaskHide();
                //    t.grids.main.load();
                //    t.forms.main.items[2].setValue(0);
                }else{
                    t.waitMaskHide();
                }
            });
            t.stores.setRights.on('error',function(data){
                //console.log('error');
                //console.log(this);
                t.grids.main.load();
            });
            t.tabPanels.main.setActive(0);

            t.win_decreasedescription = new mj.window({
                renderTo : mj.NE(),
                title : "{{ 'OperationAuthorizationEmployee.titleWinDecrease'|trans }}",
                modal : true,
                width : 400,
                height : 200,
                minWidth : 200,
                minHeight : 200,
                buttons : [
                    {title: mj.lng.glb.exit, iconCls:'mj-menu-exit-icon',handler:function(){t.win_decreasedescription.hide();}},
                    {title: mj.lng.glb.save, iconCls:'mj-save',handler:function(){
                        if(!t.txtdusursebep.getValue()||t.txtdusursebep.getValue()==''){
                            t.messageShow(t,mj.lng.glb.error,"{{ 'OperationAuthorizationEmployee.errDecreaseDescription'|trans }}");
                        }else{
                            var p=t.stores.setRights.params;
                            p.description=t.txtdusursebep.getValue();
                            t.waitMaskShow();
                            var routeName = t.modulename + '-setRights';
                            var route = Routing.getRoute(routeName);
                            var pagerParams = {'pg':1,'lm':(t.f_el_txt_opname.getElValue().length>3?5000:20)/*,'employee':t.f_el_cmb_employee.getValue(),'opname':t.f_el_txt_opname.getElValue()*/};
                            var url = Routing.generate(routeName, pagerParams);
                            t.stores.setRights.url=url;
                            t.stores.setRights.preloaded=false;
                            t.stores.setRights.params.menuId=t.id;
                            t.stores.setRights.load();
                            delete p.s1;
                            delete p.s2;
                            delete p.s3;
                            delete p.s4;
                            //delete p.s5;
                            t.win_decreasedescription.hide();
                        }
                    }}
                ]
            });
            t.win.addRelated(t.win_decreasedescription);
            t.forms.dusursebep = new mj.form({
                renderTo : t.win_decreasedescription.getBody(),
                store : new mj.store({}),
                buttonPos:false,
                items:[
                    new mj.form.textArea({
                        title : "{{ 'OperationAuthorizationEmployee.description'|trans }}",
                        dataIndex : 'description',
                        labelWidth : '80px',
                        width:280,
                        height:120
                    })
                ]
            });
            t.txtdusursebep=t.forms.dusursebep.items[0];

            t.win_questions = new mj.window({
                renderTo : mj.NE(),
                title : '',
                modal : true,
                width : 900,
                height : 400,
                minWidth : 900,
                minHeight : 400,
                buttons : [
                    {title: mj.lng.glb.exit, iconCls:'mj-menu-exit-icon',handler:function(){t.win_questions.hide();}},
                    {title: mj.lng.glb.save, iconCls:'mj-save',handler:function(){
                        //var s=0;
                        //var j=0;
                        t._flag=true;
                        var kontrol,_kontrol,operasyonyetkisoruId;
                        t.kontrolcevap=[];
                        var obj_tmp={};
                        for(var i=0;i<t.forms.kontrol.items.length;i++){
                            var item=t.forms.kontrol.items[i];
                            if(item.dataIndex){
                                if(item.dataIndex.indexOf("operasyonyetkisoruId-")>-1){
                                    if(typeof obj_tmp.operasyonyetkisoruId!=='undefined'){
                                        t.kontrolcevap.push(obj_tmp);
                                        obj_tmp={};
                                    }
                                    operasyonyetkisoruId=item.getValue();
                                    obj_tmp.operasyonyetkisoruId=operasyonyetkisoruId;
                                }
                                if(item.dataIndex.indexOf("answer-")>-1){
                                    var val=item.getValue()==1?'1':'0';
                                    obj_tmp.question=item.title;
                                    obj_tmp.answer=val;
                                    //t.stores.kontrolsoru.data[j].answer=val;
                                    //if(t._flag){
                                    //	if(!(parseInt(val)>=parseInt(t.stores.kontrolsoru.data[j].cevapmin)&&parseInt(val)<=parseInt(t.stores.kontrolsoru.data[j].cevapmax))){
                                    //		t._flag=false;
                                    //	}
                                    //}
                                    //j++;
                                    //t.kontrolcevap.push({operasyonyetkisoruId:operasyonyetkisoruId,answer:val});
                                }
                                if(item.dataIndex.indexOf("description-")>-1){
                                    obj_tmp.description=item.getValue();
                                    if(!obj_tmp.description||obj_tmp.description==''){
                                        t.messageShow(t,mj.lng.glb.error,"{{ 'OperationAuthorizationEmployee.errDecreaseDescription'|trans }}");
                                        return;
                                    }
                                }
                            }
                        }
                        t.kontrolcevap.push(obj_tmp);
                        var sr=t.grids.main.selectedRow;
                        var idx=sr.data.id;
                        t.win_questions.waitMask[0].style.display='block';
                        t.win_questions.buttons[0].setDisable();
                        t.win_questions.buttons[1].setDisable();
                        t.forms.kontrol.removeAll();
                        var routeName = 'OperationAuthorizationEmployee-setAnswers';
                        var route = Routing.getRoute(routeName);
                        var pagerParams = {};
                        var url = Routing.generate(routeName, pagerParams);
                        //var data = {opname:t.grids.main.selectedRow.data.opname,employee:t.f_el_cmb_employee.getValue(),menuId : t.id, answers:t.kontrolcevap};
                        t.stores.setAnswers.url=url;
                        t.stores.setAnswers.preloaded=false;
                        t.stores.setAnswers.params.menuId=t.id;
                        t.stores.setAnswers.params.opname=sr.data.opname;
                        t.stores.setAnswers.params.employee=t.f_el_cmb_employee.getValue();
                        t.stores.setAnswers.params.answers=t.kontrolcevap;
                        t.stores.setAnswers.load();
                    }}
                ]
            });
            
            t.win_questions.waitMask = $(mj.NE(t.win_questions.getBody(),{
                cls:'mj-page-wait-mask mj-opacity-8',
                style:'display:none;width:100%;height:100%;',
                html:'<table width="100%" height="100%"><tr><td align="center" valign="middle"><img src="'+mj.glb.imagePath+'ajax-loader.gif"/><br/><br/><span class="mj-page-wait-title">'+mj.lng.glb.pleaseWait+'</span></td></tr></table>'
            }));
            t.win_questions.waitMask.renderTo = t.win_questions.getBody();
            
            t.win.addRelated(t.win_questions);
            
            t.forms.kontrol = new mj.form({
                renderTo : t.win_questions.getBody(),
                store : new mj.store({}),
                buttonPos:false
            });
            
            t.stores.getQuestions.on("load",function(data){
                t.win_questions.waitMask[0].style.display='none';
                t.win_questions.buttons[0].setEnable();
                t.win_questions.buttons[1].setEnable();
                t.forms.kontrol.removeAll();
                t.itemCount=parseFloat(this.recordCount);
                for(var i=0;i<t.itemCount;i++){
                    //console.dir(this.data[i]);
                    var arr_item=[
                        new mj.form.numberField({
                            title : mj.lng.glb.id,
                            dataIndex : 'operasyonyetkisoruId-'+i,
                            labelWidth : '30px',
                            width : 40,
                            hidden:true,
                            initValue:this.data[i].id
                        }),
                        new mj.form.checkBox({
                            title : this.data[i].question,
                            labelWidth : '800px',
                            width : 110,
                            dataIndex : 'answer-'+i,
                            initValue:parseInt(this.data[i].answer),
                            checked:parseInt(this.data[i].answer)==1,
                            itemStyle:"white-space: normal;"
                        })
                    ];
                    if(this.data[i].isdescriptionrequire=="1"){
                        arr_item.push(
                            new mj.form.textField({
                                title : "{{ 'OperationAuthorizationEmployee.description'|trans }}",
                                dataIndex : 'description-'+i,
                                labelWidth : '70px',
                                width : 740,
                                maxLength : 250,
                                initValue:this.data[i].description,
                                notEmpty : true
                            })
                        );
                    }
                    t.forms.kontrol.add(
                        new mj.form.fieldSet({
                            id : 'f'+i,
                            title : 'Soru '+(i+1),
                            labelWidth : '110px',
                            width : 830,
                            height : this.data[i].isdescriptionrequire=="1"?80:60,
                            style : 'margin-top: 5px;',
                            items:arr_item
                        })
                    );
                }
                for(var i=0;i<t.forms.kontrol.items.length;i++){
                    var item=t.forms.kontrol.items[i];
                    if(item.title==="{{ 'OperationAuthorizationEmployee.description'|trans }}"){
                        item.setElValue(item.initValue);
                    }
                }
            });
            
            t.stores.setAnswers.on("load",function(data){
                t.win_questions.hide();
            });
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
